<?php
/**
 * Joomla! 1.5 component Cu3er
 *
 * @version $Id: slides.php 2011-04-12 05:17:53 svn $
 * @author MADEBYPLAY
 * @package Joomla
 * @subpackage Cu3er
 * @license GNU/GPL
 *
 * Cu3er component for Joomla 1.5
 *
 * This component file was created using the Joomla Component Creator by Not Web Design
 * http://www.notwebdesign.com/joomla_component_creator/
 *
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

// Include Slideshow table
JTable::addIncludePath(JPATH_COMPONENT.DS.'tables');

class Cu3erModelSlides extends JModel {

    	var $total = null;

	/**
	 * Constructor
	 *
	 * @since 1.0
	 */
	function __construct() {
		parent::__construct();
	}    	

	/**
	 * Slideshow list getter method
	 *
	 * @access 	public
	 * @return 	array array of slides
	 */	
	function getData() {
		$mainframe = &JFactory::getApplication();		
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');		
		$db = & JFactory::getDBO();
		$slideshow_id = JRequest::getInt('cid');

		if ($slideshow_id == NULL) {
			$slideshow_id = JRequest::getInt('slideshow_id');
		}

		// setting ORDER BY clause for SQL query
		$filter_order = $mainframe->getUserStateFromRequest($option.$view.'filter_order', 'filter_order', 'ordering', 'cmd');
		$filter_order_Dir = $mainframe->getUserStateFromRequest($option.$view.'filter_order_Dir', 'filter_order_Dir', '', 'word');		
		
		$query = 	"SELECT id, slideshow_id, image, caption, published, ordering " .
				"FROM #__cu3er__slides " .
				"WHERE slideshow_id = {$slideshow_id}";
		
		$query .= " ORDER BY {$filter_order} {$filter_order_Dir}";

		$db->setQuery($query);
		
		// getting query result object
		$rows = $db->loadObjectList();

		$this->total = count($rows);
		
		return $rows;
	}
	
	function getSlideShowData($slideshow_id = NULL) {
		$mainframe = &JFactory::getApplication();		
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');		
		$db = & JFactory::getDBO();
		$slideshow_id = JRequest::getInt('cid');

		if ($slideshow_id == NULL) {
			$slideshow_id = JRequest::getInt('slideshow_id');
		}
		
		$query = 	"SELECT * " .
				"FROM #__cu3er__slideshows " .
				"WHERE id = {$slideshow_id}";

		$db->setQuery($query);
		
		// getting query result object
		$rows = $db->loadObjectList();

		$this->total = count($rows);
		
		return $rows;
	}
	
	function setNewOrders($slideshow_id = NULL, $hasJS = false, $path = '') {
		$mainframe = &JFactory::getApplication();		
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');		
		$db = & JFactory::getDBO();
		$slideshow_id = JRequest::getInt('cid');

		if ($slideshow_id == NULL) {
			$slideshow_id = JRequest::getInt('slideshow_id');
		}
		
		$query = 	"SELECT * " .
				"FROM #__cu3er__slides " .
				"WHERE slideshow_id = {$slideshow_id} " .
				"ORDER BY position ASC";

		$db->setQuery($query);
		
		// getting query result object
		$rows = $db->loadObjectList();
		$i = 0;
		foreach($rows as $row) {
			print_r($row) ."<br /><br />";
			if($hasJS) {
				$old = $row->position + 1;
				$new = $i + 1;
				chmod($path, 0777);
				chmod($path . '/slide' . $old . '.png', 0777);
				chmod($path . '/thumb_slide' . $old . '.png', 0777);
				rename($path . '/slide' . $old . '.png', $path . '/slide' . $new . '.png');
				rename($path . '/thumb_slide' . $old . '.png', $path . '/thumb_slide' . $new . '.png');
				chmod($path . '/slide' . $new . '.png', 0755);
				chmod($path . '/thumb_slide' . $new . '.png', 0755);
			}
			$row1[$i] = & JTable::getInstance('Cu3erSlide', 'Table');
			$row1[$i]->load($row->id);
			$row1[$i]->ordering = $i;
			$row1[$i]->position = $i;
			$row1[$i]->store();
			unset($row1[$i]);
			$i++;
		}
	}


	/**
	 * Slide list entry counter method
	 *
	 * @access public
	 * @return number of slides
	 */
	function getTotal() {
		
		return $this->total;
	}

	/**
	 * Add new slide method
	 *
	 * @access public
	 */
	function add() {
		$mainframe = &JFactory::getApplication();
		// redirecting to slide view		
		$mainframe->redirect('index.php?option=com_cu3er&view=slide&empty=1&slideshow_id='.JRequest::getInt('slideshow_id'));
	}

	/**
	 * Slide duplicator method
	 *
	 * @access public
	 */
	function duplicate() {
		$mainframe = &JFactory::getApplication();
		$db = & JFactory::getDBO();
		$cid = JRequest::getVar('cid', array (0), 'post', 'array');

		// duplicated slide IDs for query string
		$dupids = "&dupid[]=" . implode("&dupid[]=", $cid);
		
		$slideshow_id = JRequest::getVar('slideshow_id');
		$total = count($cid);

		$row = & JTable::getInstance('Cu3erSlide', 'Table');

		$query = "SELECT image FROM #__cu3er__slides " .
			 "WHERE slideshow_id = {$slideshow_id}";

		$db->setQuery($query);		
		$images = $db->loadResultArray();
		
		$slideshow = $this->getSlideShowData($slideshow_id);
		if($this->hasJavaScript($slideshow[0]->images_folder)) {
			$path = $this->getFallbackPath($slideshow[0]->images_folder);
			$hasJS = true;
		}

		// cycling thru all slides
		for ($i = 0; $i < $total; $i++) {
			$query = "SELECT * FROM #__cu3er__slides " .
				 "WHERE id = {$cid[$i]}";

			$db->setQuery($query);
			$result = $db->loadAssoc();

			// setting slide to null for the slide clone			
			$result['id'] = null;

			$j = 1;

/*			// original name
			$gen_name = $result['image'];
			
			// generating slide name
			while (in_array($gen_name, $images)) {
				$gen_name = (($j > 1)?'#'.$j.' ':'') . JText::_('copy of') . ' ' . $result['image'];
				$j++;
			}

			// setting image name			
			$result['image'] = $gen_name;

*/
			$oldPosition = $result['position'] + 1;
			// counting slide position number		
			$result['ordering'] = $result['position'] = $this->getLastPosition(JRequest::getInt('slideshow_id')) + 1;
			if($hasJS) {
				copy($path . '/slide' . $oldPosition . '.png', $path . '/slide' . ($result['position'] + 1) . '.png');
				copy($path . '/thumb_slide' . $oldPosition . '.png', $path . '/thumb_slide' . ($result['position'] + 1) . '.png');
			}
			// binding, checking and storing cloned slide values			
			if (!$row->bind($result) || !$row->check() || !$row->store()) {
				$mainframe->redirect('index.php?option=com_cu3er&view=slides&cid='. JRequest::getInt('slideshow_id'), $row->getError(), 'error');
			} else {
				// setting id to null for the next possible slide clone entry				
				$row->id = null;
			}

		}

		$cache = & JFactory::getCache('com_cu3er');
		$cache->clean();

		$msg = 'Slide(s) duplicated';

		// calling CU3ER-generated.xml generator method
		if (!$this->callXMLGen($row->slideshow_id)) {
			$msg = 'Unable to generate CU3ER-generated.xml file'; 
		}

		$mainframe->redirect('index.php?option=com_cu3er&view=slides&cid='.$row->slideshow_id . $dupids, JText::_($msg));
	}

	/**
	 * Slide publisher method
	 *
	 * @access public
	 * @param int $publish publishing trigger (0 - unpublished, 1 - published)
	 */
	function publish($publish = 1) {

		$mainframe = &JFactory::getApplication();
		$cid = JRequest::getVar('cid');

		// referencing JTable instance
		$row = & JTable::getInstance('Cu3erSlide', 'Table');

		$slideshow_id = JRequest::getInt('slideshow_id');

		// handling multiple slides
		foreach ($cid as $id) {
			$row->load($id);

			// publish/unpublish slideshow
			$row->publish($id, $publish);
		}
		$cache = & JFactory::getCache('com_cu3er');
		$cache->clean();

		// calling CU3ER-generated.xml generator method
		if (!$this->callXMLGen($slideshow_id)) {
			$msg = 'Unable to generate CU3ER-generated.xml file'; 
		}

		$mainframe->redirect('index.php?option=com_cu3er&view=slides&cid='.$slideshow_id);
	}

	/**
	 * Slide unpublisher method
	 *
	 * @access public
	 */
	function unpublish() {
		$this->publish(0);
	}


	/**
	 * Slide order saver method
	 *
	 * @access public
	 */
	function saveorder() {
		$mainframe = &JFactory::getApplication();
		$db = & JFactory::getDBO();
	
		// getting requested IDs
		$cid = JRequest::getVar('cid', array (0), 'post', 'array');
		$total = count($cid);

		// getting requested orders
		$order = JRequest::getVar('order', array (0), 'post', 'array');

		JArrayHelper::toInteger($order, array (0));

		$row = & JTable::getInstance('Cu3erSlide', 'Table');

		// cycling thru slides		
		for ($i = 0; $i < $total; $i++) {
			$row->load(( int )$cid[$i]);
			// if order of slide has changed
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				// updating ordering				
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg());
				}
			}
		}

		// setting `position` table field equal to `ordering` field
		$this->reposition($row->slideshow_id);

		$cache = & JFactory::getCache('com_cu3er');
		$cache->clean();
		$msg = 'New ordering saved';

		// calling CU3ER-generated.xml generator method
		if (!$this->callXMLGen($row->slideshow_id)) {
			$msg = 'Unable to generate CU3ER-generated.xml file'; 
		}

		$mainframe->redirect('index.php?option=com_cu3er&view=slides&cid='.$row->slideshow_id, JText::_($msg));
	}


	/**
	 * Method decreases the ordering value of a slide
	 *
	 * @access public
	 * @param int $num ordering value modifier
	 */
	function orderup($num = -1) {
		
		$mainframe = &JFactory::getApplication();
		$cid = JRequest::getVar('cid');

		// referencing JTable instance
		$row = & JTable::getInstance('Cu3erSlide', 'Table');

		// loading slide entry
		$row->load($cid[0]);
		$slideshow = $this->getSlideShowData($row->slideshow_id);
		if($this->hasJavaScript($slideshow[0]->images_folder)) {
			$path = $this->getFallbackPath($slideshow[0]->images_folder);
			$position = $row->position + 1;
			chmod($path . '/slide' . $position . '.png', 0777);
			chmod($path . '/thumb_slide' . $position . '.png', 0777);
			chmod($path . '/slide' . ($position + $num) . '.png', 0777);
			chmod($path . '/thumb_slide' . ($position + $num) . '.png', 0777);
			// rename current fallback image to slide_{current}_1.png
			rename($path . '/slide' . $position . '.png', $path . '/slide' . $position . '_1.png');
			rename($path . '/thumb_slide' . $position . '.png', $path . '/thumb_slide' . $position . '_1.png');
			// rename old fallback image to slide_{current}.png
			rename($path . '/slide' . ($position + $num) . '.png', $path . '/slide' . $position . '.png');
			rename($path . '/thumb_slide' . ($position + $num) . '.png', $path . '/thumb_slide' . $position . '.png');
			// rename current fallback image to slide_{current + num}.png
			rename($path . '/slide' . $position . '_1.png', $path . '/slide' . ($position + $num) . '.png');
			rename($path . '/thumb_slide' . $position . '_1.png', $path . '/thumb_slide' . ($position + $num) . '.png');
			chmod($path . '/slide' . $position . '.png', 0755);
			chmod($path . '/thumb_slide' . $position . '.png', 0755);
			chmod($path . '/slide' . ($position + $num) . '.png', 0755);
			chmod($path . '/thumb_slide' . ($position + $num) . '.png', 0755);
		}
		// stepping forward/backward by 1
		$row->move($num);

		// setting `position` table field equal to `ordering` field
		$this->reposition($row->slideshow_id);
		
		$cache = & JFactory::getCache('com_cu3er');
		$cache->clean();
		$msg = 'New ordering saved';

		// calling CU3ER-generated.xml generator method
		if (!$this->callXMLGen($row->slideshow_id)) {
			$msg = 'Unable to generate CU3ER-generated.xml file'; 
		}

		$mainframe->redirect('index.php?option=com_cu3er&view=slides&cid='.$row->slideshow_id, JText::_($msg));
	}

	/**
	 * Method increases the ordering value of a slide
	 *
	 * @access public
	 */
	function orderdown() {
		$this->orderup(1);
	}

	/**
	 * Slide removal method
	 *
	 * @access public
	 */
	function remove() {
		$mainframe = &JFactory::getApplication();

		// getting requested IDs
		$cid = JRequest::getVar('cid', array (0), 'post', 'array');
		$total = count($cid);
		$slideshow_id = JRequest::getInt('slideshow_id');

		$hasJS = false;
		$path = '';
		$row = & JTable::getInstance('Cu3erSlide', 'Table');
		$slideshow = $this->getSlideShowData($slideshow_id);
		if($this->hasJavaScript($slideshow[0]->images_folder)) {
			$path = $this->getFallbackPath($slideshow[0]->images_folder);
			$hasJS = true;
		}

		// cycling thru slides
		for ($i = 0; $i < $total; $i++) {
			// delete entry by id
			if($hasJS) {
				$row1[$i] = & JTable::getInstance('Cu3erSlide', 'Table');
				$row1[$i]->load($cid[$i]);
				$position = $row1[$i]->position + 1;
				chmod($path . '/slide' . $position . '.png', 0777);
				chmod($path . '/thumb_slide' . $position . '.png', 0777);
				unlink($path . '/slide' . $position . '.png');
				unlink($path . '/thumb_slide' . $position . '.png');
				unset($row1[$i]);
			}
			$row->delete($cid[$i]);
		}

		$cache = & JFactory::getCache('com_cu3er');
		$cache->clean();
		$msg = 'Slide(s) removed ';
		
		$this->setNewOrders($slideshow_id, $hasJS, $path);

		// calling CU3ER-generated.xml generator method
		if (!$this->callXMLGen($slideshow_id)) {
			$msg = 'Unable to generate CU3ER-generated.xml file'; 
		}
	
		$mainframe->redirect('index.php?option=com_cu3er&view=slides&cid='.$slideshow_id, JText::_($msg));
	}

	/**
	 * Slide position regenerator method
	 *
	 * @access public
	 * @param int $num ordering position modifier
	 */
	function reposition($slideshow_id) {
		$db =& JFactory::getDBO();
		$db->Execute(	"UPDATE #__cu3er__slides " .
				"SET position = ordering " .
				"WHERE slideshow_id = '{$slideshow_id}'");
	}

	/**
	 * Highest slide position getter method
	 *
	 * @access public
	 * @param int $slideshow_id slideshow ID
	 * @return int maximum value of ordering field
	 */
	function getLastPosition($slideshow_id) {
		$db =& JFactory::getDBO();
		$query = "SELECT max(ordering) FROM #__cu3er__slides ".
			 "WHERE slideshow_id = {$slideshow_id}";

		$db->setQuery($query);
		$result = $db->loadRow();
		return (int)$result[0];
	}

	/**
	 * Custom XML file generator caller method
	 *
	 * @access public
	 * @param int $slideshow_id slideshow ID
	 */
	function callXMLGen($slideshow_id) {
	
		require_once(JPATH_COMPONENT_ADMINISTRATOR.DS.'lib'.DS.'cu3erfile.class.php');
		return (Cu3erFile::generateXMLFile($slideshow_id));
		
	}

	/**
	 * Slideshow name getter method
	 *
	 * @access public
	 * @param int $slideshow_id slideshow ID
	 * @return string name of slideshow
	 */
	function getSlideshowName($slideshow_id) {
		$db =& JFactory::getDBO();
		$query = "SELECT LOWER(name) FROM #__cu3er__slideshows ".
			 "WHERE id = {$slideshow_id}";

		$db->setQuery($query);
		$result = $db->loadResult();
		return $result;
	}
	
	function hasJavaScript($path) {
		$rootDir = dirname(dirname(dirname(dirname(dirname(__FILE__)))));
		$tempPath = explode("/", $path);
		$delFlag = true;
		for($i =0; $i<sizeof($tempPath); $i++) {
			if($delFlag) {
				if($tempPath[$i] == 'images') {
					$delFlag = false;
				} else {
					unset($tempPath[$i]);
				}
			}
		}
		$realPath = $rootDir . '/' . implode('/', $tempPath);
		return is_dir($realPath . '/fallback');
	}
	
	function getFallbackPath($path) {
		$rootDir = dirname(dirname(dirname(dirname(dirname(__FILE__)))));
		$realPath = $rootDir . substr($path, (strpos($path, basename($rootDir)) + strlen(basename($rootDir)) ));
		return $realPath . '/fallback';
	}

}
